/*
 * callbacks_JSON.c
 */

#include <callbacks.h>

static bool getBoolFromString(char * string);
static bool parityCheck_write(uint8_t addr, uint8_t data);
static bool parityCheck_read(uint8_t addr);

// ***** Application Callback Functions to Process data *****

//****************************MCT8316Z Callbacks*******************************

void GUICallback_nSLEEP(char * string)
{
    // Example to receive a boolean
        nSLEEP =  getBoolFromString(string);
        if (nSLEEP == true)
        {
            nSLEEP_on_flag = 1;
            nSLEEP_off_flag = 0;
        }
        else
        {
            nSLEEP_on_flag = 0;
            nSLEEP_off_flag = 1;
        }
}

void GUICallback_nFAULT(char * string)
{
   nFAULT =  getBoolFromString(string);

   SPI_Write(0x04, 0x03); //clear nFAULT keep ansych modulation
}

//****************************Motor Callbacks**********************************


void GUICallback_PwmSel(char * string)
{
    PwmSel = strtol(string, NULL, 10);
}

void GUICallback_PwmDuty(char * string)
{
    PwmDuty = strtol(string, NULL, 10);
}

void GUICallback_NumPol(char * string)
{
    NumPoles = strtol(string, NULL, 10);
}


//****************************SPI Function Callbacks******************************

void GUICallback_Addr(char * string)
{
    UartAddr = strtol(string, NULL, 10);
}


void GUICallback_Data(char * string)
{
    UartData = strtol(string, NULL, 10);
}

void GUICallback_Read(char * string)
{
    UartRead = getBoolFromString(string);
    ReadFlag = 1;
}

void GUICallback_Write(char * string)
{
   UartWrite = getBoolFromString(string);
   WriteFlag = 1;

   SPI_Write(UartAddr,UartData);

   //UpdateSpiReg(UartAddr,UartData);
}

void GUICallback_ReadAll(char * string)
{
    ReadAllFlag = getBoolFromString(string);
    ReadAllFlag = 1;
}

void GUICallback_WriteAll(char * string)
{
    WriteAllFlag = getBoolFromString(string);
    SPI_Write_All();
}

//********************SPI Register Callbacks***********************

//CTRL1

void GUICallback_Reg_Lock2(char * string)
{
    REG_LOCK2 = strtol(string, NULL, 10);
}

void GUICallback_Reg_Lock1(char * string)
{
    REG_LOCK1 = strtol(string, NULL, 10);
}

void GUICallback_Reg_Lock0(char * string)
{
    REG_LOCK0 = strtol(string, NULL, 10);
}

//CTRL2

void GUICallback_Slew1(char * string)
{
    SLEW1 = strtol(string, NULL, 10);
}

void GUICallback_Slew0(char * string)
{
    SLEW0 = strtol(string, NULL, 10);
}

void GUICallback_Pwm_Mode1(char * string)
{
    PWM_MODE1 = strtol(string, NULL, 10);
}

void GUICallback_Pwm_Mode0(char * string)
{
    PWM_MODE0 = strtol(string, NULL, 10);
}

void GUICallback_Clr_Flt(char * string)
{
    CLR_FLT = strtol(string, NULL, 10);
}

//CTRL3

void GUICallback_Ovp_Sel(char * string)
{
    OVP_SEL = strtol(string, NULL, 10);
}

void GUICallback_Ovp_En(char * string)
{
    OVP_EN = strtol(string, NULL, 10);
}

void GUICallback_Spi_Flt_Rep(char * string)
{
    SPI_FLT_REP = strtol(string, NULL, 10);
}

void GUICallback_Otw_Rep(char * string)
{
    OTW_REP = strtol(string, NULL, 10);
}

//CTRL4

void GUICallback_Ocp_Cbc(char * string)
{
    OCP_CBC = strtol(string, NULL, 10);
}

void GUICallback_Ocp_Deg1(char * string)
{
    OCP_DEG1 = strtol(string, NULL, 10);
}

void GUICallback_Ocp_Deg0(char * string)
{
    OCP_DEG0 = strtol(string, NULL, 10);
}

void GUICallback_Ocp_Retry(char * string)
{
    OCP_RETRY = strtol(string, NULL, 10);
}

void GUICallback_Ocp_Lvl(char * string)
{
    OCP_LVL = strtol(string, NULL, 10);
}

void GUICallback_Ocp_Mode1(char * string)
{
    OCP_MODE1 = strtol(string, NULL, 10);
}

void GUICallback_Ocp_Mode0(char * string)
{
    OCP_MODE0 = strtol(string, NULL, 10);
}

//CTRL5

void GUICallback_Bemf_Th(char * string)
{
    BEMF_TH = strtol(string, NULL, 10);
}

void GUICallback_Ilim_Recir(char * string)
{
    ILIM_RECIR = strtol(string, NULL, 10);
}

void GUICallback_Ad_Comp_Th_Ls(char * string)
{
    AD_COMP_TH_LS = strtol(string, NULL, 10);
}

void GUICallback_Ad_Comp_Th_Hs(char * string)
{
    AD_COMP_TH_HS = strtol(string, NULL, 10);
}

void GUICallback_En_Aar(char * string)
{
    EN_AAR = strtol(string, NULL, 10);
}

void GUICallback_En_Asr(char * string)
{
    EN_ASR = strtol(string, NULL, 10);
}

void GUICallback_Csa_Gain1(char * string)
{
    CSA_GAIN1 = strtol(string, NULL, 10);
}

void GUICallback_Csa_Gain0(char * string)
{
    CSA_GAIN0 = strtol(string, NULL, 10);
}

//CTRL6

void GUICallback_Buck_SR(char * string)
{
    BUCK_SR = strtol(string, NULL, 10);
}
void GUICallback_Buck_Ps_Dis(char * string)
{
    BUCK_PS_DIS = strtol(string, NULL, 10);
}
void GUICallback_Buck_Sel1(char * string)
{
    BUCK_SEL1 = strtol(string, NULL, 10);
}
void GUICallback_Buck_Sel0(char * string)
{
    BUCK_SEL0 = strtol(string, NULL, 10);
}
void GUICallback_Buck_Dis(char * string)
{
    BUCK_DIS = strtol(string, NULL, 10);
}

//CTRL7

void GUICallback_Hall_Hys(char * string)
{
    HALL_HYS = strtol(string, NULL, 10);
}
void GUICallback_Brake_Mode(char * string)
{
    BRAKE_MODE = strtol(string, NULL, 10);
}
void GUICallback_Coast(char * string)
{
    COAST = strtol(string, NULL, 10);
}
void GUICallback_Brake(char * string)
{
    BRAKE = strtol(string, NULL, 10);
}
void GUICallback_Dir(char * string)
{
    DIR = strtol(string, NULL, 10);
}

//CTRL8

void GUICallback_Fg_Mode1(char * string)
{
    FG_MODE1 = strtol(string, NULL, 10);
}

void GUICallback_Fg_Mode0(char * string)
{
    FG_MODE0 = strtol(string, NULL, 10);
}

void GUICallback_Dis_Mtr_Lock(char * string)
{
    DIS_MTR_LOCK = strtol(string, NULL, 10);
}

void GUICallback_Motor_Lock_Retry(char * string)
{
    MOTOR_LOCK_RETRY = strtol(string, NULL, 10);
}

void GUICallback_Motor_Lock_Tdet1(char * string)
{
    MOTOR_LOCK_TDET1 = strtol(string, NULL, 10);
}

void GUICallback_Motor_Lock_Tdet0(char * string)
{
    MOTOR_LOCK_TDET0 = strtol(string, NULL, 10);
}

void GUICallback_Motor_Lock_Mode1(char * string)
{
    MOTOR_LOCK_MODE1 = strtol(string, NULL, 10);
}

void GUICallback_Motor_Lock_Mode0(char * string)
{
    MOTOR_LOCK_MODE0 = strtol(string, NULL, 10);
}

//CTRL9

void GUICallback_Advance2(char * string)
{
    ADVANCE2 = strtol(string, NULL, 10);
}

void GUICallback_Advance1(char * string)
{
    ADVANCE1 = strtol(string, NULL, 10);
}

void GUICallback_Advance0(char * string)
{
    ADVANCE0 = strtol(string, NULL, 10);
}


//*******************************Data Functions***************************************

static bool getBoolFromString(char * string)
{
    if (strncmp(string, "true", 4) == 0)
    {
        return true;
    }
    else
    {
        return false;
    }
}

void GUICallback_QMathData(char * string)
{
    qIncrement = strtol(string, NULL, 10);
}
